#include "stdafx.h"
#include "TextManager.h"

Text *TextManager::Load( const std::string & path )
{
	FILE *f = fopen( path.c_str(), "r" );
	if ( !f )
		return 0;

	fseek( f, 0, SEEK_END );
	const int fileSize = ftell( f );
	fseek( f, 0, SEEK_SET );
	if ( fileSize <= 0 )
	{
		fclose(f);
		return 0;
	}

	const int bufSize = fileSize / sizeof(wchar_t) + 1;

	wchar_t *ptr = new wchar_t[ bufSize ];
	fread( (void*)&ptr[0], 1, fileSize, f );
	ptr[ bufSize - 1 ] = L'\0';
	
	fclose(f);

	return new Text(ptr);
}

void TextManager::Delete( Text *res )
{
	delete res;
}

TextManager & GetTextManager()
{
	static TextManager m;
	return m;
}